<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>JR3.30 - Load Students Json to Table</title>

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- nhúng thư viện awsome font  -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
     <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  

</head>
<body>
    <div class="container">
        <h2 class="text-center">Danh sách sinh viên</h2>
        <button class="btn btn-success" id="btn-them"><i class="fas fa-user-plus fa-lg">&nbsp;</i>Thêm sinh viên</button>
       <br><br>
        <!-- content  -->
        <div class="float-center">
            <table class="table table-bordered table-striped table-hover table-primary" id="table-student">
                <thead>
                  <tr>
                    <th>ID</th>
                    <th><Nav>NAME</Nav></th>
                    <th>BIRTHDAY</th>
                    <th>EMAIL</th>
                    <th>PHONE</th>
                    <th>ACTION</th>

                  </tr>
              </table>
        </div>
        <!-- content -->
    </div>

<!-- modal them sinh vien  -->
    <form id="form-them">
    <div class="modal" tabindex="-1" role="dialog" id="modal-create">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">Thêm sinh viên</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <!-- modal body  -->
            <div class="modal-body">
                <div class="row form-group">
                    <div class="col-4">
                        <label class="label">Name</label>
                    </div>
                    <div class="col">
                        <input required class="form-control" id="inp-name">
                    </div>
                </div>

                <div class="row form-group">
                    <div class="col-4">
                        <label class="label">Birthday</label>
                    </div>
                    <div class="col">
                        <input required type="date" class="form-control" id="inp-birthday">
                    </div>
                </div>

                <div class="row form-group">
                    <div class="col-4">
                        <label class="label">Email</label>
                    </div>
                    <div class="col">
                        <input required type="email" class="form-control" id="inp-email">
                    </div>
                </div>

                <div class="row form-group">
                    <div class="col-4">
                        <label class="label">Phone number</label>
                    </div>
                    <div class="col">
                        <input required type="number" class="form-control" id="inp-phone-number">
                    </div>
                </div>  
              
            </div>
             <!--end  modal body  -->
            <div class="modal-footer">
              <button type="submit" class="btn btn-primary"><i class="fas fa-user-plus fa-lg">&nbsp;</i>Thêm sinh viên </button>
              <button type="button" class="btn btn-warning" data-dismiss="modal">cancel</button>
            </div>
          </div>
        </div>
    </div>
    </form>
<!-- end modal them sinh vien  -->
   

<!-- modal update sinh vien  -->
     <form id="form-update">
        <div class="modal" tabindex="-1" role="dialog" id="modal-update">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title">Update sinh viên</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <!-- modal body  -->
                <div class="modal-body">
                    <div class="row form-group">
                        <div class="col-4">
                            <label class="label">Name</label>
                        </div>
                        <div class="col">
                            <input required class="form-control" id="inp-name-update">
                        </div>
                    </div>
    
                    <div class="row form-group">
                        <div class="col-4">
                            <label class="label">Birthday</label>
                        </div>
                        <div class="col">
                            <input required type="date" class="form-control" id="inp-birthday-update">
                        </div>
                    </div>
    
                    <div class="row form-group">
                        <div class="col-4">
                            <label class="label">Email</label>
                        </div>
                        <div class="col">
                            <input required type="email" class="form-control" id="inp-email-update">
                        </div>
                    </div>
    
                    <div class="row form-group">
                        <div class="col-4">
                            <label class="label">Phone number</label>
                        </div>
                        <div class="col">
                            <input required type="number" class="form-control" id="inp-phone-number-update">
                        </div>
                    </div>  
                  
                </div>
                 <!--end  modal body  -->
                <div class="modal-footer">
                  <button type="submit" class="btn btn-primary"><i class="fas fa-user-edit fa-lg">&nbsp;</i>Update sinh viên </button>
                  <button type="button" class="btn btn-warning" data-dismiss="modal">cancel</button>
                </div>
              </div>
            </div>
        </div>
        </form>
       
 <!-- end modal update sinh vien  -->

  <!-- modal Delete sinh vien  -->
 
    <div class="modal" tabindex="-1" role="dialog" id="modal-delete">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">Delete sinh viên</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <!-- modal body  -->
            <div class="modal-body">
                <h6 class="text-danger" id="h3-text"></h6>
            </div>
             <!--end  modal body  -->
            <div class="modal-footer">
              <button type="button" id="btn-xoa" class="btn btn-primary"><i class="fas fa-user-slash fa-lg">&nbsp;</i>Delete sinh viên </button>
              <button type="button" class="btn btn-warning" data-dismiss="modal">cancel</button>
            </div>
          </div>
        </div>
    </div>
   
   
    <!-- end modal Delete sinh vien  -->
    
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATE_SUCCESS = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://devcamp-student-datatables.herokuapp.com/users/";
       //creata a data for DataTable
       const gCOLUMN_ID = 0;
        const gCOLUMN_HO_TEN = 1;
        const gCOLUMN_BIRTHDAY = 2;
        const gCOLUMN_EMAIL = 3;
        const gCOLUMN_PHONE = 4 ;
        const gCOLUMN_ACTION = 5;
        

        const gNAME_COL = ["id","name","birthday","email",
            "phone","Action"];
            
            // định nghĩa table  - chưa có data
         var gUserTable = $("#table-student").DataTable( {
            // Khai báo các cột của datatable
            "columns" : [
                { "data" : gNAME_COL[gCOLUMN_ID] },
                { "data" : gNAME_COL[gCOLUMN_HO_TEN] },
                { "data" : gNAME_COL[gCOLUMN_BIRTHDAY] },
                { "data" : gNAME_COL[gCOLUMN_EMAIL] },
                { "data" : gNAME_COL[gCOLUMN_PHONE] },
                { "data" : gNAME_COL[gCOLUMN_ACTION] }
            ],
            // Ghi đè nội dung của cột action, chuyển thành button chi tiết
            "columnDefs": [ 
            {
                "targets": gCOLUMN_ACTION,
                // "defaultContent": "<button class='info-user btn btn-info'>Chi tiết</button>"
               // "defaultContent":  '<i class="fas fa-edit fa-lg edit-icon text-left" style="cursor:pointer; color:green;"></i>&nbsp;&nbsp;&nbsp;&nbsp;<i class="fas fa-trash-alt fa-lg delete-icon  text-right"  style="cursor:pointer; color:red;"></i>'
               "defaultContent": "<button class='update-user btn btn-info'>update</button> &nbsp;&nbsp;<button class='delete-user btn btn-danger'>delete</button>  "
            }]
        });
        var gStudent;
        onPageLoading();
/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  

    //function on click update
        $("#table-student").on("click",".update-user",function(){
            gStudent = getCurrentInfo(this);
            console.log(gStudent);
           loadDataStudentToModalUpdate(gStudent);
           $("#modal-update").modal("show");
           
        })

    //handle onclick update
    $("#form-update").on("submit",function(event){
        event.preventDefault();
        onBtnUpdateMoiSinhVien();
    })
    //end function on click update
    
     //function on click delete
        $("#table-student").on("click",".delete-user",function(){
        gStudent = getCurrentInfo(this);
        $("#h3-text").text("bạn chó chắc muốn xóa sinh viên có id: " + gStudent.id + " ?")  
        $("#modal-delete").modal("show");
            
        })
     //end function on click delete
     //Sự kiện delete một student
     $("#btn-xoa").on("click",function(){
        deleteUser();
     })
    //on button thêm mới một sinh viên
        $("#btn-them").on("click",function(){
            console.log("thêm mới sinh viên");
        $("#modal-create").modal("show");
        })
    //end on button thêm mới một sinh viên

    //sự kiện khi ấn nút thêm mới trong modal
    $("#form-them").on("submit",function(event){
        event.preventDefault();
        onBtnThemMoiSinhVien();
    })

    
    

         /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
    //load table 
        function onPageLoading(){
            debugger;
            getAllUsers();
        }
        // Mẫu gọi API load all users
        function getAllUsers() {
        // create a request
        var vXmlHttObj = new XMLHttpRequest();
        vXmlHttObj.open("GET", gBASE_URL, true);
        vXmlHttObj.send();
        vXmlHttObj.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(vXmlHttObj.responseText);
                var vListStudent = JSON.parse(vXmlHttObj.responseText);
                loadDataToTable(vListStudent);
            }
        }
        }
        //load table 
    function loadDataToTable(paramResponseObject) {
      //Xóa toàn bộ dữ liệu đang có của bảng
      gUserTable.clear();
      //Cập nhật data cho bảng 
      gUserTable.rows.add(paramResponseObject);
      //Cập nhật lại giao diện hiển thị bảng
      gUserTable.draw();
    }

     //function get Current info on click button Chi tiet
     function getCurrentInfo(paraBtn){
        var vTrCurrent = $(paraBtn).closest("tr");
        console.log(vTrCurrent);
        var vTable = $("#table-student").DataTable();
        var vCurrentInfo = vTable.row(vTrCurrent).data();
        return vCurrentInfo;
    }
//*****XƯ LÝ MODAL THÊM MỚI MỘT SINH VIÊN***************
    // function thêm mới một sinh viên 
    function onBtnThemMoiSinhVien(){
            var vNewStudent = {
                "name": "",
                "email": "",
                // "password": "nmacdearmaid0",
                "phone": "",
                "birthday": "",
                // "gender": "Female",
            }

            getNewStudent(vNewStudent);
            if(!validate(vNewStudent)){return;}
            
            insertUser(vNewStudent);
        }
    //END function thêm mới một sinh viên 
    // Mẫu gọi API Insert user (thêm user)
    function insertUser(paraStudent) {
        //data to be sent (4 thuộc tính)
        // var vObjectRequestData = {
        //     "name": "Nanette MacDearmaid",
		// 	"email": "nmacdearmaid0@ucla.edu",
		// 	"password": "nmacdearmaid0",
		// 	"phone": "185-129-2326",
		// 	"birthday": "11/18/1995",
		// 	"gender": "Female",
        // };
        var vObjectRequestData = paraStudent;
        var vXmlhttp = new XMLHttpRequest();

        vXmlhttp.open("POST", gBASE_URL, true);
        vXmlhttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        vXmlhttp.send(JSON.stringify(vObjectRequestData));

        vXmlhttp.onreadystatechange = function() {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_CREATE_SUCCESS) {
                console.log(this.responseText);
                handleInsertStudentSuccess()
            }
        }
    }

    //function getnewstudent
    function getNewStudent(paraStudent){
        paraStudent.name = $("#inp-name").val().trim();
        paraStudent.birthday = $("#inp-birthday").val().trim();
        paraStudent.email = $("#inp-email").val().trim();
        paraStudent.phone = $("#inp-phone-number").val().trim();
    }

    //kiem tra Student Object

    function validate(paraStudent){
       if( paraStudent.name == "" || paraStudent.birthday == "" ||
        paraStudent.email == "" || paraStudent.phone == ""){
            alert("dữ liệu không hợp lệ");
            return false;
        }
        return true;
    }

    //điểu khiển sau khi inssert thành công
    function handleInsertStudentSuccess(){
        alert("thêm sinh viên thành công");
        $("#modal-create").modal("hide");
        resetAllInPut();
        //tải lại danh sách sinh viên
        getAllUsers();
    }

    //reset all input Create
    function resetAllInPut(){
        $("#inp-name").val("");
        $("#inp-birthday").val("");
        $("#inp-email").val("");
        $("#inp-phone-number").val("");
    }
//*****END XƯ LÝ MODAL THÊM MỚI MỘT SINH VIÊN***************

//*****XƯ LÝ MODAL UPDATE MỘT SINH VIÊN***************
//load dữ liệu lên modal update
function loadDataStudentToModalUpdate(paraStudent){
    $("#inp-name-update").val(paraStudent.name);
    $("#inp-birthday-update").val(paraStudent.birthday);
    $("#inp-email-update").val(paraStudent.email);
    $("#inp-phone-number-update").val(paraStudent.phone);

}
//function on click btn update sinh viên
function onBtnUpdateMoiSinhVien(){
    var vNewStudent = {
                "name": "",
                "email": "",
                // "password": "nmacdearmaid0",
                "phone": "",
                "birthday": "",
                // "gender": "Female",
            }

        getNewStudentUpdate(vNewStudent);
        if(!validate(vNewStudent)){return;}
       updateUserById(vNewStudent);
       
}
 //function getnewstudent update
 function getNewStudentUpdate(paraStudent){
        paraStudent.name = $("#inp-name-update").val().trim();
        paraStudent.birthday = $("#inp-birthday-update").val().trim();
        paraStudent.email = $("#inp-email-update").val().trim();
        paraStudent.phone = $("#inp-phone-number-update").val().trim();
    }

 // Mẫu gọi API Update user by Id
    function updateUserById(paraStudent) {
        // id user sẽ update
        // var vUserId = "1";
        // //data to be sent  (6 thuộc tính)
        // var vObjectRequestData = {
        //     "name": "Nanette MacDearmaid",
		// 	"email": "nmacdearmaid0@ucla.edu",
		// 	"password": "nmacdearmaid0",
		// 	"phone": "185-129-2326",
		// 	"birthday": "11/18/1995",
		// 	"gender": "Female",
        // };
        var vUserId = gStudent.id;
        debugger;
        var vObjectRequestData = paraStudent;
  
        var vXmlhttp = new XMLHttpRequest();

        vXmlhttp.open("PUT", gBASE_URL + vUserId, true);
        vXmlhttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        vXmlhttp.send(JSON.stringify(vObjectRequestData));
        
        vXmlhttp.onreadystatechange = function() {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(vXmlhttp.responseText);
                handleUpdateStudentSuccess();
            }
        }
    }

     //điểu khiển sau khi update thành công
    function handleUpdateStudentSuccess(){
        alert("update sinh viên thành công");
        $("#modal-update").modal("hide");
       
        //tải lại danh sách sinh viên
        getAllUsers();
    }
//*****END XƯ LÝ MODAL UPDATE MỘT SINH VIÊN***************

//*****XƯ LÝ MODAL DELETE MỘT SINH VIÊN***************
//function xóa sinh vien
function deleteUser() {
        // id user sẽ xóa
        // var vUserId = "9";
        var vUserId = gStudent.id;
        
        var vXmlhttp = new XMLHttpRequest();
        vXmlhttp.open("DELETE", gBASE_URL + vUserId, true);
        vXmlhttp.send();

        vXmlhttp.onreadystatechange = function() {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                alert("Xóa thành công, user id = " + vUserId);
                handleDeletSuccess();
            }
        }
    }

//function xử lý sau khi xóa
function handleDeletSuccess(){
    getAllUsers();
    $("#modal-delete").modal("hide");
}
</script>
</html>